(POJ 2528)Mayor's posters 线段树 + 离散化

Mayor’s posters
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 59580 Accepted: 17267
Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for placing the posters and introduce the following rules:
Every candidate can place exactly one poster on the wall.
All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
The wall is divided into segments and the width of each segment is one byte.
Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.
Your task is to find the number of visible posters when all the posters are placed given the information about posters’ size, their place and order of placement on the electoral wall.
Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li <= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,… , ri.
Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10
Sample Output

4
Source

Alberta Collegiate Programming Contest 2003.10.18

题意:
往一个墙上铁海报,海报可以相互覆盖,问最后从上面可以看到多少张海报。

分析:
这是一个典型的线段树区间修改的问题。 每次对一个最长10^7的线段进行线段树的区间修改, 最后统计。
线段树的复杂度是log10^7, 应该不会超时, 但是会超内存。 所以想到要离散化, 将区间端点值有映射成一个尽量小的值。
关于离散化:
我们将所有的端点进行排序去重后,原先端点的在排序并去重的数组中的下标位子则为新的离散化后的位子。但是这样存在一定的问题,如:
输入为
1
3
1 10
1 3
5 10
在进行排序去重后结果为1 3 5 10 原先的1 ->10 对应 1 -> 4 ;1 ->3 对应 1 -> 2 ;5 ->10 对应 3-> 4 ;正确的答案应该是可以看到三张海报,离散化后就只能看到2张了。 问题在于两个短的没有盖住全部的大的,但是离散后就出了问题。所以我们可以在每段后面进行留白,使被压在后面的但又没有完全压住的得以显现出来。

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
using namespace std;

const int maxn = 11111;
int T,n,ans,tr[maxn<<4],x[maxn<<3];
bool vis[maxn];

struct node
{
    int l,r;
    node(int ll=0,int rr=0):l(ll),r(rr){};
    bool operator < (const node& rhs)const
    {
        return l<rhs.l || (l == rhs.l && r< rhs.r);
    }
};
node a[maxn];

void update(int L,int R,int v,int l,int r,int o)
{
    if(L<=l && r<=R)
    {
        tr[o] = v;
        return ;
    }
    if(tr[o])
    {
        tr[o<<1] = tr[o<<1|1] = tr[o];
        tr[o] = 0;
    }
    int m = (l+r)>>1;
    if(L <= m) update(L,R,v,l,m,o<<1);
    if(R > m) update(L,R,v,m+1,r,o<<1|1);
}

void query(int l,int r,int o)
{
    if(tr[o])
    {
        if(!vis[tr[o]])
        {
            ans++;
            vis[tr[o]]=true;
        }
        return ;
    }
    if(l==r) return;
    int m = (l+r)>>1;
    query(l,m,o<<1);
    query(m+1,r,o<<1|1);
}

int main()
{
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d",&n);
        int cnt=0;
        //输入并离散化
        for(int i=1;i<=n;i++)
        {
            scanf("%d%d",&a[i].l,&a[i].r);
            x[cnt++]=a[i].l;x[cnt++]=a[i].r;
        }
        sort(x,x+cnt);
        cnt = unique(x,x+cnt) - x;
        int m = cnt;
        for(int i=1;i<cnt;i++)
        {
            if(x[i]-x[i-1]>1) x[m++]=x[i]+1;//加空白
        }
        sort(x,x+m);

        memset(vis,0,sizeof(vis));//别忘了初始化
        memset(tr,0,sizeof(tr));
        for(int i=1;i<=n;i++)
        {
            int l = lower_bound(x,x+m,a[i].l) - x + 1;  //从1开始
            int r = lower_bound(x,x+m,a[i].r) - x + 1;
            update(l,r,i,1,m,1);
        }
        ans = 0;
        query(1,m,1);
        printf("%d\n",ans);
    }
    return 0;
}
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值